<template>
  <!-- <div> -->
  <!-- <div>1111111111111111111111111111111111111111</div> -->
  <div
    :class="className"
    :style="{ height: height, width: width }"
  />
  <!-- </div> -->
</template>

<script>
import * as echarts from 'echarts' // echarts theme
// import resize from './mixins/resize'
require('echarts/theme/macarons')

export default {
  // mixins: [resize],
  props: {
    className: {
      type: String,
      default: 'chart',
    },
    width: {
      type: String,
      default: '100%',
    },
    height: {
      type: String,
      default: '350px',
    },
    autoResize: {
      type: Boolean,
      default: true,
    },
    chartData: {
      type: Object,
      required: true,
    },
    // xdata: {
    //   type: Array,
    //   required: true
    // }
  },
  data () {
    return {
      chart: null,
    }
  },
  watch: {
    chartData: {
      handler (val) {
        this.setOptions(val)
      },
      deep: true
    },
  },
  mounted () {
    this.$nextTick(() => {
      this.initChart()
    })
  },
  beforeDestroy () {
    if (!this.chart) {
      return
    }
    this.chart.dispose()
    this.chart = null
  },
  methods: {
    initChart () {
      this.chart = echarts.init(this.$el, 'macarons')
      this.chart.clear()
      // this.setOptions(this.chartData)
    },
    setOptions (val) {
      console.log('val,val', val)
      // val.series.forEach(element => {
      //   element.data = element.data.map(item => item === 0 ? 0.1 : item)
      // })
      if (this.chart) {
        this.chart.clear()
      }
      let that = this
      function fontSize (res) {
        let clientWidth =
          window.innerWidth ||
          document.documentElement.clientWidth ||
          document.body.clientWidth
        if (!clientWidth) return
        let fontSize = 100 * (clientWidth / 1920)
        return res * fontSize
      }
      /**
   * 增加监听，mouseover事件（鼠标放在上面）
   * 节点事件触发 是默认开启的，我们再开启了线事件触发后，
   * 目前鼠标放在线上或者放在节点上都能触发下面的监听，
   * 事件触发后，修改series内对应系列的参数配置。
   * 注：params内包含系列名称等信息
   */
      this.chart.on('mouseover', function (params) {
        that.chart.setOption({
          series: [
            {
              name: params.seriesName,
              label: {
                show: true,
                fontSize: 16,
                position: [10, -15],
                formatter: '{c}'
              }
            }
          ]
        })
      })
      // 增加监听，mouseout事件（鼠标离开）
      this.chart.on('mouseout', function (params) {
        that.chart.setOption({
          series: [
            {
              name: params.seriesName,
              lineStyle: {
                width: 2
              },
              label: {
                show: false
              },
              endLabel: {
                show: false
              }
            }
          ]
        })
      })
      this.chart.setOption(
        {
          xAxis: {
            data: val.xAxis,
            boundaryGap: false,
            axisTick: {
              show: true,
            },

          },
          grid: {
            left: '5%',
            right: '5%',
            top: '5%',
            containLabel: true,
            height: fontSize(4.3),
          },
          tooltip: {
            trigger: 'axis',
            backgroundColor: 'rgba(50,50,50,0.5)',
            textStyle: {
              color: 'rgb(255, 255, 255);',
              fontSize: fontSize(0.117), // 字体大小
              lineHeight: 0
            }
          },
          yAxis: val.yAxis,
          legend: {
            data: val.title,
            tooltip: {
              show: true,
            },
            textStyle: {
              fontSize: fontSize(0.15),
            },
            widht: 'auto',
            height: 'auto',
            top: fontSize(5.5),
          },
          dataZoom: [
            {
              type: 'inside',
              start: 0,
              end: 100,
            },
            {
              start: 0,
              end: 10,
              top: fontSize(4.5),
              height: fontSize(0.4),
            },
          ],
          series: val.series
        },
        true
      )
      // window.onresize = this.chart.resize
    },
  },
}
</script>
